import java.io.*;
import java.math.BigInteger;
import java.util.*;
import java.text.DecimalFormat;
 
public class H2 {
    static StreamTokenizer in = new StreamTokenizer(new BufferedReader(new InputStreamReader(System.in)));
 
    static int nextInt() throws IOException {
        in.nextToken();
        return (int) in.nval;
    }
 
    static long nextLong() throws IOException {
        in.nextToken();
        return (long) in.nval;
    }
 
    static double nextDouble() throws IOException {
        in.nextToken();
        return in.nval;
    }
 
    static String next() throws IOException {
        in.nextToken();
        return in.sval;
    }
 
    static PrintWriter out = new PrintWriter(new OutputStreamWriter(System.out));
 
    static int n;
    static long[] a = new long[100005];
    static long[] des = new long[100005];
    static int[] par = new int[100005];
    static long ans[] = new long[100005];
    static boolean[] vis = new boolean[100005];
    static long[] s = new long[100005];
 
    static void init() {
        for (int i = 0; i <= 100000; i++) {
            par[i] = i;
        }
        Arrays.fill(vis, false);
        Arrays.fill(a,0);
        Arrays.fill(des,0);
        Arrays.fill(ans,0);
        Arrays.fill(s,0);
    }
 
    static int findx(long x) {
        if (par[(int) x] == x)
            return (int) x;
        else
            return par[(int) x] = findx(par[(int) x]);
    }
 
    static void unite(long x, long y) {
        int fx = findx(x);
        int fy = findx(y);
        par[fy] = fx;
        s[fx] += s[fy];
    }
 
    public static void main(String[] args) throws IOException {
        int T = nextInt();
        while (T-- > 0) {
            init();
            n = nextInt();
            for (int i = 1; i <= n; i++) {
                a[i] = nextLong();
            }
            for (int i = 1; i <= n; i++) {
                des[i] = nextLong();
                s[(int) des[i]] = a[(int) des[i]];
            }
            ans[n] = 0;
            for (int i = n; i >= 2; i--) {
                if (des[i] < n && vis[(int) (des[i] + 1)]) {
                    unite(des[i], des[i] + 1);
                }
                if (des[i] > 1 && vis[(int) (des[i] - 1)]) {
                    unite(des[i], des[i] - 1);
                }
                vis[(int) des[i]] = true;
                ans[i] = Math.max(ans[i + 1], s[(int) des[i]]);
            }
            for (int i = 2; i <= n + 1; i++) {
                out.println(ans[i]);
            }
            out.flush();
        }
    }
}
